$(function() {
$("#scheduler").dxScheduler({
timeZone: "America/Los_Angeles",
dataSource: data,
views: ["day", "month"],
currentView: "month",
currentDate: new Date(2021, 2, 25),
firstDayOfWeek: 1,
startDayHour: 9,
groups: undefined,
recurrenceEditMode: "series",
onAppointmentContextMenu: function (e) {
updateContextMenu(false, appointmentContextMenuItems, ".dx-scheduler-appointment", itemTemplate, onItemClick(e));
},
onCellContextMenu: function (e) {
updateContextMenu(false, cellContextMenuItems, ".dx-scheduler-date-table-cell", 'item', onItemClick(e));
},
resources: [{
fieldExpr: "roomId",
dataSource: resourcesData,
label: "Room"
}],
height: 600
});
var contextMenuInstance = $("#context-menu").dxContextMenu({
width: 200,
dataSource: [],
disabled: true,
onHiding: function() {
updateContextMenu(true, []);
}
}).dxContextMenu("instance");
var updateContextMenu = function (disable, dataSource, target, itemTemplate, onItemClick) {
contextMenuInstance.option({
dataSource: dataSource,
target: target,
itemTemplate: itemTemplate,
onItemClick: onItemClick,
disabled: disable,
});
}
var itemTemplate = function(itemData) {
return getAppointmentMenuTemplate(itemData);
}
var onItemClick = function(contextMenuEvent) {
return function (e) {
e.itemData.onItemClick(contextMenuEvent, e);
}
}
var createAppointment = function (e) {
e.component.showAppointmentPopup({
startDate: e.cellData.startDate
}, true);
};
var createRecurringAppointment = function (e) {
e.component.showAppointmentPopup({
startDate: e.cellData.startDate,
recurrenceRule: "FREQ=DAILY"
}, true);
};
var groupCell = function(e) {
var scheduler = e.component;
if(scheduler.option("groups")) {
scheduler.option({ crossScrollingEnabled: false, groups: undefined });
} else {
scheduler.option({ crossScrollingEnabled: true, groups: ["roomId"] });
}
};
var showCurrentDate = function (e) {
e.component.option("currentDate", new Date());
};
var showAppointment = function (e) {
e.component.showAppointmentPopup(e.appointmentData);
};
var deleteAppointment = function (e) {
e.component.deleteAppointment(e.appointmentData);
};
var repeatAppointmentWeekly = function (e) {
var itemData = e.appointmentData;
e.component.updateAppointment(itemData, $.extend(itemData, {
startDate: e.targetedAppointmentData.startDate,
recurrenceRule: "FREQ=WEEKLY"
}));
};
var setResource = function (e, clickEvent) {
var itemData = e.appointmentData;
e.component.updateAppointment(itemData, $.extend(itemData, {
roomId: [clickEvent.itemData.id]
}));
};
var cellContextMenuItems = [
{ text: 'New Appointment', onItemClick: createAppointment },
{ text: 'New Recurring Appointment', onItemClick: createRecurringAppointment },
{ text: 'Group by Room/Ungroup', beginGroup: true, onItemClick: groupCell },
{ text: 'Go to Today', onItemClick: showCurrentDate }
];
var appointmentContextMenuItems = [
{ text: 'Open', onItemClick: showAppointment },
{ text: 'Delete', onItemClick: deleteAppointment },
{ text: 'Repeat Weekly', beginGroup: true, onItemClick: repeatAppointmentWeekly },
{ text: 'Set Room', beginGroup: true, disabled: true }
];
$.each(resourcesData, function (i, item) {
item.onItemClick = setResource;
});
appointmentContextMenuItems = $.merge(appointmentContextMenuItems, resourcesData);
var getAppointmentMenuTemplate = function(itemData) {
var template = $('<div></div>');
if(itemData.color) {
template.append("<div class='item-badge' style='background-color:" + itemData.color + ";'></div>");
}
template.append(itemData.text);
return template;
};
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script>
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/20.2.5/css/dx.common.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/20.2.5/css/dx.light.css" />
<script src="https://cdn3.devexpress.com/jslib/20.2.5/js/dx.all.js"></script>
<script src="data.js"></script>
<script src="index.js"></script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="context-menu"></div>
<div id="scheduler"></div>
</div>
</body>
</html>
.dx-menu-item-content span {
margin-right: 5px;
}
.dx-menu-item-has-submenu .dx-icon-spinright {
position: absolute;
top: 7px;
right: 2px;
}
.item-badge {
text-align: center;
float: left;
margin-right: 12px;
color: white;
width: 18px;
height: 18px;
font-size: 19.5px;
border-radius: 18px;
margin-top: 2px;
}
var data = [
{
text: "Watercolor Landscape",
roomId: [1],
startDate: new Date("2021-03-01T17:30:00.000Z"),
endDate: new Date("2021-03-01T19:00:00.000Z"),
recurrenceRule: "FREQ=WEEKLY;BYDAY=TU,FR;COUNT=10"
}, {
text: "Oil Painting for Beginners",
roomId: [2],
startDate: new Date("2021-03-01T17:30:00.000Z"),
endDate: new Date("2021-03-01T19:00:00.000Z"),
recurrenceRule: "FREQ=WEEKLY;BYDAY=MO,TH;COUNT=10"
}, {
text: "Testing",
roomId: [3],
startDate: new Date("2021-03-01T20:00:00.000Z"),
endDate: new Date("2021-03-01T21:00:00.000Z"),
recurrenceRule: "FREQ=WEEKLY;BYDAY=MO;WKST=TU;INTERVAL=2;COUNT=2"
}, {
text: "Meeting of Instructors",
roomId: [4],
startDate: new Date("2021-03-01T17:00:00.000Z"),
endDate: new Date("2021-03-01T17:15:00.000Z"),
recurrenceRule: "FREQ=DAILY;BYDAY=WE;UNTIL=20210401"
}, {
text: "Recruiting students",
roomId: [5],
startDate: new Date("2021-02-24T18:00:00.000Z"),
endDate: new Date("2021-02-24T19:00:00.000Z"),
recurrenceRule: "FREQ=YEARLY;BYWEEKNO=14",
recurrenceException: "20210411T170000Z"
}, {
text: "Final exams",
roomId: [3],
startDate: new Date("2021-02-24T20:00:00.000Z"),
endDate: new Date("2021-02-24T21:35:00.000Z"),
recurrenceRule: "FREQ=YEARLY;BYWEEKNO=15;BYDAY=TH,FR"
}, {
text: "Monthly Planning",
roomId: [4],
startDate: new Date("2021-03-24T22:30:00.000Z"),
endDate: new Date("2021-03-24T23:45:00.000Z"),
recurrenceRule: "FREQ=MONTHLY;BYMONTHDAY=28;COUNT=1"
}, {
text: "Open Day",
roomId: [5],
startDate: new Date("2021-03-01T17:30:00.000Z"),
endDate: new Date("2021-03-01T21:00:00.000Z"),
recurrenceRule: "FREQ=YEARLY;BYYEARDAY=87"
}
];
var resourcesData = [
{
text: "Room 101",
id: 1,
color: "#bbd806"
}, {
text: "Room 102",
id: 2,
color: "#f34c8a"
}, {
text: "Room 103",
id: 3,
color: "#ae7fcc"
}, {
text: "Meeting room",
id: 4,
color: "#ff8817"
}, {
text: "Conference hall",
id: 5,
color: "#03bb92"
}
];

<dx-scheduler
timeZone="America/Los_Angeles"
[crossScrollingEnabled]="crossScrollingEnabled"
[dataSource]="appointmentsData"
[views]='["day", "month"]'
currentView="month"
[groups]="groups"
recurrenceEditMode= "series"
[currentDate]="currentDate"
(onCellContextMenu)="onCellContextMenu($event)"
(onAppointmentContextMenu)="onAppointmentContextMenu($event)"
[startDayHour]="9"
[height]="600">
<dxi-resource
fieldExpr="roomId"
label="room"
[dataSource]="resourcesData"
></dxi-resource>
</dx-scheduler>
<dx-context-menu #contextMenu
[dataSource]="dataSource"
[disabled]="disabled"
[target]="target"
(onItemClick)="onContextMenuItemClick($event)"
[width]="200"
(onHiding)="onContextMenuHiding($event)">
<div *dxTemplate="let e of 'item'">
<div *ngIf="e.color">
<div class="item-badge" [ngStyle]="{ backgroundColor: e.color}"></div>
</div>
<div class="item-text">{{e.text}}</div>
</div>
</dx-context-menu>
import { NgModule, Component, enableProdMode, ViewChild, ViewChildren, QueryList } from '@angular/core';
import {BrowserModule} from '@angular/platform-browser';
import {platformBrowserDynamic} from '@angular/platform-browser-dynamic';
import {Appointment, Resource, ResourceMenuItem, Service} from './app.service';
import { DxContextMenuModule, DxContextMenuComponent } from 'devextreme-angular';
import {DxSchedulerModule, DxSchedulerComponent} from 'devextreme-angular';
if(!/localhost/.test(document.location.host)) {
enableProdMode();
}
@Component({
selector: 'demo-app',
templateUrl: 'app/app.component.html',
styleUrls: ['app/app.component.css'],
providers: [Service]
})
export class AppComponent {
@ViewChild(DxSchedulerComponent, { static: false }) scheduler: DxSchedulerComponent;
@ViewChild('contextMenu', { static: false }) contextMenu: DxContextMenuComponent;
appointmentsData: Appointment[];
currentDate: Date = new Date(2020, 10, 25);
resourcesData: Resource[];
groups: any;
crossScrollingEnabled: boolean = false;
dataSource: any[] = [];
disabled: boolean = true;
target: any;
onContextMenuItemClick: any;
cellContextMenuItems: any[];
appointmentContextMenuItems: any[];
constructor(service: Service) {
const that = this;
const resourcesMenuItems = [];
that.resourcesData = service.getResources();
that.appointmentsData = service.getAppointments();
that.cellContextMenuItems = [
{ text: 'New Appointment', onItemClick: that.createAppointment },
{ text: 'New Recurring Appointment', onItemClick: that.createRecurringAppointment },
{ text: 'Group by Room/Ungroup', beginGroup: true, onItemClick: that.groupCell },
{ text: 'Go to Today', onItemClick: that.showCurrentDate }
];
that.resourcesData.forEach(function (item) {
let menuItem: ResourceMenuItem = {
text: item.text,
id: item.id,
color: item.color,
onItemClick: that.setResource.bind(that)
}
resourcesMenuItems.push(menuItem);
});
that.appointmentContextMenuItems = [
{ text: 'Open', onItemClick: this.showAppointment },
{ text: 'Delete', onItemClick: this.deleteAppointment },
{ text: 'Repeat Weekly', beginGroup: true, onItemClick: this.repeatAppointmentWeekly },
{ text: 'Set Room', beginGroup: true, disabled: true }
];
that.appointmentContextMenuItems = that.appointmentContextMenuItems.concat(resourcesMenuItems);
}
setResource(e, clickEvent) {
const itemData = e.appointmentData;
e.component.updateAppointment(itemData, {
itemData,
...{ roomId: [clickEvent.itemData.id] }
});
}
createAppointment(e) {
e.component.showAppointmentPopup({
startDate: e.cellData.startDate
}, true);
}
createRecurringAppointment(e) {
e.component.showAppointmentPopup({
startDate: e.cellData.startDate,
recurrenceRule: "FREQ=DAILY"
}, true);
}
groupCell() {
if(this.groups && this.groups.length) {
this.crossScrollingEnabled = false;
this.groups=[];
} else {
this.groups = ["roomId"];
this.crossScrollingEnabled = true;
};
}
showCurrentDate() {
this.currentDate = new Date();
}
showAppointment(e) {
e.component.showAppointmentPopup(e.appointmentData);
}
deleteAppointment(e) {
e.component.deleteAppointment(e.appointmentData);
}
repeatAppointmentWeekly(e) {
const itemData = e.appointmentData;
e.component.updateAppointment(itemData, {
itemData, ...{
startDate: e.targetedAppointmentData.startDate,
recurrenceRule: "FREQ=WEEKLY"
}
});
}
onItemClick(contextMenuEvent) {
return function (e) {
e.itemData.onItemClick(contextMenuEvent, e);
}
}
onAppointmentContextMenu(e) {
this.target = ".dx-scheduler-appointment";
this.disabled = false;
this.dataSource = this.appointmentContextMenuItems;
this.onContextMenuItemClick = this.onItemClick(e);
}
onCellContextMenu(e) {
this.target = ".dx-scheduler-date-table-cell";
this.disabled = false;
this.dataSource = this.cellContextMenuItems;
this.onContextMenuItemClick = this.onItemClick(e);
}
onContextMenuHiding() {
this.disabled = true;
this.dataSource = [];
}
}
@NgModule({
imports: [
BrowserModule,
DxSchedulerModule,
DxContextMenuModule
],
declarations: [AppComponent],
bootstrap: [AppComponent]
})
export class AppModule { }
platformBrowserDynamic().bootstrapModule(AppModule);
::ng-deep .item-badge {
text-align: center;
float: left;
margin-right: 12px;
color: white;
width: 18px;
height: 18px;
font-size: 19.5px;
border-radius: 18px;
margin-top: 2px;
}
import { Injectable } from "@angular/core";
export class Appointment {
text: string;
roomId: number[];
startDate: Date;
endDate: Date;
recurrenceRule?: string;
recurrenceException?: string;
}
export class Resource {
text: string;
id: number;
color: string;
}
export class ResourceMenuItem {
text: string;
id: number;
color: string;
onItemClick: any;
}
let appointments: Appointment[] = [
{
text: "Watercolor Landscape",
roomId: [1],
startDate: new Date("2020-11-01T17:30:00.000Z"),
endDate: new Date("2020-11-01T19:00:00.000Z"),
recurrenceRule: "FREQ=WEEKLY;BYDAY=MO,TH;COUNT=10"
}, {
text: "Oil Painting for Beginners",
roomId: [2],
startDate: new Date("2020-11-01T17:30:00.000Z"),
endDate: new Date("2020-11-01T19:00:00.000Z"),
recurrenceRule: "FREQ=WEEKLY;BYDAY=SU,WE;COUNT=10"
}, {
text: "Testing",
roomId: [3],
startDate: new Date("2020-11-01T20:00:00.000Z"),
endDate: new Date("2020-11-01T21:00:00.000Z"),
recurrenceRule: "FREQ=WEEKLY;BYDAY=SU;WKST=TU;INTERVAL=2;COUNT=2"
}, {
text: "Meeting of Instructors",
roomId: [4],
startDate: new Date("2020-11-01T17:00:00.000Z"),
endDate: new Date("2020-11-01T17:15:00.000Z"),
recurrenceRule: "FREQ=DAILY;BYDAY=TU;UNTIL=20201203"
}, {
text: "Recruiting students",
roomId: [5],
startDate: new Date("2020-10-24T18:00:00.000Z"),
endDate: new Date("2020-10-24T19:00:00.000Z"),
recurrenceRule: "FREQ=YEARLY;BYWEEKNO=50;WKST=SU",
recurrenceException: "20201212T190000Z"
}, {
text: "Final exams",
roomId: [3],
startDate: new Date("2020-10-24T20:00:00.000Z"),
endDate: new Date("2020-10-24T21:35:00.000Z"),
recurrenceRule: "FREQ=YEARLY;BYWEEKNO=51;BYDAY=WE,TH"
}, {
text: "Monthly Planning",
roomId: [4],
startDate: new Date("2020-11-24T22:30:00.000Z"),
endDate: new Date("2020-11-24T23:45:00.000Z"),
recurrenceRule: "FREQ=MONTHLY;BYMONTHDAY=28;COUNT=1"
}, {
text: "Open Day",
roomId: [5],
startDate: new Date("2020-11-01T17:30:00.000Z"),
endDate: new Date("2020-11-01T21:00:00.000Z"),
recurrenceRule: "FREQ=YEARLY;BYYEARDAY=333"
}
];
let resources: Resource[] = [
{
text: "Room 101",
id: 1,
color: "#bbd806"
}, {
text: "Room 102",
id: 2,
color: "#f34c8a"
}, {
text: "Room 103",
id: 3,
color: "#ae7fcc"
}, {
text: "Meeting room",
id: 4,
color: "#ff8817"
}, {
text: "Conference hall",
id: 5,
color: "#03bb92"
}
];
@Injectable()
export class Service {
getAppointments(): Appointment[] {
return appointments;
}
getResources(): Resource[] {
return resources;
}
}
// In real applications, you should not transpile code in the browser. You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
System.config({
transpiler: 'ts',
typescriptOptions: {
module: "system",
emitDecoratorMetadata: true,
experimentalDecorators: true
},
meta: {
'typescript': {
"exports": "ts"
},
'devextreme/localization.js': {
"esModule": true
}
},
paths: {
'npm:': 'https://unpkg.com/'
},
map: {
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@3.5.3/lib/typescript.js',
'@angular': 'npm:@angular',
'tslib': 'npm:tslib@2.1.0/tslib.js',
'rxjs': 'npm:rxjs@6.4.0',
'rrule': 'npm:rrule@2.6.6/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.26.0/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@20.2.6',
'jszip': 'npm:jszip@3.6.0/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@0.10.3/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.0.18',
'devexpress-gantt': 'npm:devexpress-gantt@2.0.24',
'devextreme-angular': 'npm:devextreme-angular@20.2.6',
'preact': 'npm:preact@10.5.13/dist/preact.js',
'preact/hooks': 'npm:preact@10.5.13/hooks/dist/hooks.js'
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts'
},
'devextreme': {
defaultExtension: 'js'
},
'devextreme/events/utils': {
main: 'index'
},
'devextreme/events': {
main: 'index'
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js'
}
},
packageConfigPaths: [
"npm:@angular/*/package.json",
"npm:@angular/common/*/package.json",
"npm:rxjs/package.json",
"npm:rxjs/operators/package.json",
"npm:devextreme-angular/*/package.json",
"npm:devextreme-angular/ui/*/package.json",
"npm:devextreme-angular/package.json",
"npm:devexpress-diagram/package.json",
"npm:devexpress-gantt/package.json",
]
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/20.2.6/css/dx.common.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/20.2.6/css/dx.light.css" />
<script src="https://unpkg.com/core-js@2.4.1/client/shim.min.js"></script>
<script src="https://unpkg.com/zone.js@0.10.2/dist/zone.js"></script>
<script src="https://unpkg.com/reflect-metadata@0.1.3/Reflect.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import('app').catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>

<template>
<div>
<DxScheduler
ref="scheduler"
time-zone="America/Los_Angeles"
:groups="groups"
:data-source="dataSource"
:views="views"
:current-date="currentDate"
:cross-scrolling-enabled="crossScrollingEnabled"
:start-day-hour="9"
:height="600"
:on-appointment-context-menu="onAppointmentContextMenu"
:on-cell-context-menu="onCellContextMenu"
current-view="month"
recurrence-edit-mode="series"
>
<DxResource
:data-source="resourcesData"
field-expr="roomId"
label="Room"
/>
</DxScheduler>
<DxContextMenu
:items="contextMenuItems"
:width="200"
:disabled="disabled"
:target="target"
:on-item-click="onContextMenuItemClick"
item-template="itemTemplateSlot"
>
<template #itemTemplateSlot="{ data: itemData }">
<ItemTemplate :item-data="itemData"/>
</template>
</DxContextMenu>
</div>
</template>
<script>
import DxScheduler, { DxResource } from 'devextreme-vue/scheduler';
import DxContextMenu from 'devextreme-vue/context-menu';
import ItemTemplate from './ItemTemplate.vue';
import { resourcesData, data } from './data.js';
const appointmentClassName = '.dx-scheduler-appointment';
const cellClassName = '.dx-scheduler-date-table-cell';
export default {
components: {
DxScheduler,
DxResource,
DxContextMenu,
ItemTemplate,
},
data() {
return {
views: ['day', 'month'],
currentDate: new Date(2020, 10, 25),
dataSource: data,
groups: undefined,
crossScrollingEnabled: false,
resourcesData,
disabled: true,
contextMenuItems: [],
target: appointmentClassName,
};
},
methods: {
onAppointmentContextMenu({ appointmentData, targetedAppointmentData }) {
const scheduler = this.$refs.scheduler.instance;
const resourceItems = resourcesData.map((item) => ({
...item,
onItemClick: ({ itemData }) => scheduler.updateAppointment(appointmentData, {
...appointmentData,
...{ roomId: [itemData.id] },
}),
}));
this.target = appointmentClassName;
this.disabled = false;
this.contextMenuItems = [
{
text: 'Open',
onItemClick: () => scheduler.showAppointmentPopup(appointmentData),
},
{
text: 'Delete',
onItemClick: () => scheduler.deleteAppointment(appointmentData),
},
{
text: 'Repeat Weekly',
beginGroup: true,
onItemClick: () => scheduler.updateAppointment(appointmentData, {
startDate: targetedAppointmentData.startDate,
recurrenceRule: 'FREQ=WEEKLY',
}),
},
{ text: 'Set Room', beginGroup: true, disabled: true },
...resourceItems,
];
},
onCellContextMenu({ cellData }) {
const scheduler = this.$refs.scheduler.instance;
this.target = cellClassName;
this.disabled = false;
this.contextMenuItems = [
{
text: 'New Appointment',
onItemClick: () => scheduler.showAppointmentPopup(
{ startDate: cellData.startDate },
true,
),
},
{
text: 'New Recurring Appointment',
onItemClick: () => scheduler.showAppointmentPopup(
{
startDate: cellData.startDate,
recurrenceRule: 'FREQ=DAILY',
},
true,
),
},
{
text: 'Group by Room/Ungroup',
beginGroup: true,
onItemClick: () => {
if (this.groups) {
this.crossScrollingEnabled = false;
this.groups = null;
} else {
this.crossScrollingEnabled = true;
this.groups = ['roomId'];
}
},
},
{
text: 'Go to Today',
onItemClick: () => {
this.currentDate = new Date();
},
},
];
},
onContextMenuItemClick(e) {
e.itemData.onItemClick(e);
},
},
};
</script>
<style scoped>
.dx-menu-item-content span {
margin-right: 5px;
}
.dx-menu-item-has-submenu .dx-icon-spinright {
position: absolute;
top: 7px;
right: 2px;
}
</style>
<template>
<div>
<div
v-if="itemData.color"
:style="styleObject"
class="item-badge"
/>
{{ itemData.text }}
</div>
</template>
<script>
export default {
props: {
itemData: {
type: Object,
default() { },
},
},
data() {
return {
styleObject: { backgroundColor: this.itemData.color },
};
},
};
</script>
<style scoped>
.item-badge {
text-align: center;
float: left;
margin-right: 12px;
color: white;
width: 18px;
height: 18px;
font-size: 19.5px;
border-radius: 18px;
margin-top: 2px;
}
</style>
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html>
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/22.1.4/css/dx.common.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/22.1.4/css/dx.light.css" />
<script src="https://unpkg.com/core-js@2.4.1/client/shim.min.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.js");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"> </div>
</div>
</body>
</html>
export const data = [
{
text: 'Watercolor Landscape',
roomId: [1],
startDate: new Date('2020-11-01T17:30:00.000Z'),
endDate: new Date('2020-11-01T19:00:00.000Z'),
recurrenceRule: 'FREQ=WEEKLY;BYDAY=MO,TH;COUNT=10',
}, {
text: 'Oil Painting for Beginners',
roomId: [2],
startDate: new Date('2020-11-01T17:30:00.000Z'),
endDate: new Date('2020-11-01T19:00:00.000Z'),
recurrenceRule: 'FREQ=WEEKLY;BYDAY=SU,WE;COUNT=10',
}, {
text: 'Testing',
roomId: [3],
startDate: new Date('2020-11-01T20:00:00.000Z'),
endDate: new Date('2020-11-01T21:00:00.000Z'),
recurrenceRule: 'FREQ=WEEKLY;BYDAY=SU;WKST=TU;INTERVAL=2;COUNT=2',
}, {
text: 'Meeting of Instructors',
roomId: [4],
startDate: new Date('2020-11-01T17:00:00.000Z'),
endDate: new Date('2020-11-01T17:15:00.000Z'),
recurrenceRule: 'FREQ=DAILY;BYDAY=TU;UNTIL=20201203',
}, {
text: 'Recruiting students',
roomId: [5],
startDate: new Date('2020-10-24T18:00:00.000Z'),
endDate: new Date('2020-10-24T19:00:00.000Z'),
recurrenceRule: 'FREQ=YEARLY;BYWEEKNO=50;WKST=SU',
recurrenceException: '20201212T190000Z',
}, {
text: 'Final exams',
roomId: [3],
startDate: new Date('2020-10-24T20:00:00.000Z'),
endDate: new Date('2020-10-24T21:35:00.000Z'),
recurrenceRule: 'FREQ=YEARLY;BYWEEKNO=51;BYDAY=WE,TH',
}, {
text: 'Monthly Planning',
roomId: [4],
startDate: new Date('2020-11-24T22:30:00.000Z'),
endDate: new Date('2020-11-24T23:45:00.000Z'),
recurrenceRule: 'FREQ=MONTHLY;BYMONTHDAY=28;COUNT=1',
}, {
text: 'Open Day',
roomId: [5],
startDate: new Date('2020-11-01T17:30:00.000Z'),
endDate: new Date('2020-11-01T21:00:00.000Z'),
recurrenceRule: 'FREQ=YEARLY;BYYEARDAY=333',
},
];
export const resourcesData = [
{
text: 'Room 101',
id: 1,
color: '#bbd806',
}, {
text: 'Room 102',
id: 2,
color: '#f34c8a',
}, {
text: 'Room 103',
id: 3,
color: '#ae7fcc',
}, {
text: 'Meeting room',
id: 4,
color: '#ff8817',
}, {
text: 'Conference hall',
id: 5,
color: '#03bb92',
},
];
window.config = {
transpiler: 'plugin-babel',
meta: {
'*.vue': {
loader: 'vue-loader',
},
'devextreme/localization.js': {
'esModule': true,
},
},
paths: {
'npm:': 'https://unpkg.com/',
},
map: {
'vue': 'npm:vue@3.0.0/dist/vue.esm-browser.js',
'vue-loader': 'npm:dx-systemjs-vue-browser@1.0.15/index.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.28.0/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@22.1.4/cjs',
'devextreme-vue': 'npm:devextreme-vue@22.1.4',
'jszip': 'npm:jszip@3.7.1/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@1.5.16/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.1.63/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.32/dist/dx-gantt.js',
'@devextreme/runtime': 'npm:@devextreme/runtime@3.0.7',
'inferno': 'npm:inferno@7.4.4/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat@7.4.11/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate@7.4.11/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode@7.4.11/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class@7.4.11/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras@7.4.11/dist/inferno-extras.min.js',
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:@devextreme/runtime@3.0.7/inferno/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
},
};
System.config(window.config);

import React from 'react';
import Scheduler, { Resource } from 'devextreme-react/scheduler';
import ContextMenu from 'devextreme-react/context-menu';
import { data, resourcesData } from './data.js';
import { AppointmentMenuTemplate } from './AppointmentTemplate.js';
const views = ['day', 'month'];
const appointmentClassName = '.dx-scheduler-appointment';
const cellClassName = '.dx-scheduler-date-table-cell';
class App extends React.Component {
constructor(props) {
super(props);
this.scheduler = React.createRef();
this.state = {
currentDate: new Date(2020, 10, 25),
contextMenuItems: [],
target: appointmentClassName,
disabled: true,
};
this.onAppointmentContextMenu = this.onAppointmentContextMenu.bind(this);
this.onContextMenuItemClick = this.onContextMenuItemClick.bind(this);
this.onCellContextMenu = this.onCellContextMenu.bind(this);
}
render() {
const {
contextMenuItems, target, disabled, currentDate, groups, crossScrollingEnabled,
} = this.state;
return (
<React.Fragment>
<Scheduler
ref={this.scheduler}
timeZone="America/Los_Angeles"
dataSource={data}
views={views}
groups={groups}
crossScrollingEnabled={crossScrollingEnabled}
defaultCurrentView="month"
currentDate={currentDate}
startDayHour={9}
recurrenceEditMode="series"
onAppointmentContextMenu={this.onAppointmentContextMenu}
onCellContextMenu={this.onCellContextMenu}
height={600}
>
<Resource
dataSource={resourcesData}
fieldExpr="roomId"
label="Room"
/>
</Scheduler>
<ContextMenu
dataSource={contextMenuItems}
width={200}
target={target}
disabled={disabled}
onItemClick={this.onContextMenuItemClick}
itemRender={AppointmentMenuTemplate}
/>
</React.Fragment>
);
}
onAppointmentContextMenu({ appointmentData, targetedAppointmentData }) {
const scheduler = this.scheduler.current.instance;
const resourceItems = resourcesData.map((item) => ({
...item,
onItemClick: ({ itemData }) => scheduler.updateAppointment(appointmentData, {
...appointmentData,
...{ roomId: [itemData.id] },
}),
}));
this.setState((state) => ({
...state,
target: appointmentClassName,
disabled: false,
contextMenuItems: [
{
text: 'Open',
onItemClick: () => scheduler.showAppointmentPopup(appointmentData),
},
{
text: 'Delete',
onItemClick: () => scheduler.deleteAppointment(appointmentData),
},
{
text: 'Repeat Weekly',
beginGroup: true,
onItemClick: () => scheduler.updateAppointment(appointmentData, {
startDate: targetedAppointmentData.startDate,
recurrenceRule: 'FREQ=WEEKLY',
}),
},
{ text: 'Set Room', beginGroup: true, disabled: true },
...resourceItems,
],
}));
}
onContextMenuItemClick(e) {
e.itemData.onItemClick(e);
}
onCellContextMenu({ cellData }) {
const scheduler = this.scheduler.current.instance;
this.setState((state) => ({
...state,
target: cellClassName,
disabled: false,
contextMenuItems: [
{
text: 'New Appointment',
onItemClick: () => scheduler.showAppointmentPopup(
{ startDate: cellData.startDate },
true,
),
},
{
text: 'New Recurring Appointment',
onItemClick: () => scheduler.showAppointmentPopup(
{
startDate: cellData.startDate,
recurrenceRule: 'FREQ=DAILY',
},
true,
),
},
{
text: 'Group by Room/Ungroup',
beginGroup: true,
onItemClick: () => {
if (this.groups) {
this.setState((currentState) => ({
...currentState,
crossScrollingEnabled: false,
groups: null,
}));
} else {
this.setState((currentState) => ({
...currentState,
crossScrollingEnabled: true,
groups: ['roomId'],
}));
}
},
},
{
text: 'Go to Today',
onItemClick: () => {
this.setState((currentState) => ({
...currentState,
currentDate: new Date(),
}));
},
},
],
}));
}
}
export default App;
import React from 'react';
export function AppointmentMenuTemplate(itemData) {
return (<div>
{itemData.color ? <div className="item-badge" style={{ backgroundColor: itemData.color }} /> : ''}
{itemData.text}
</div>);
}
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
<!DOCTYPE html>
<html>
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/22.2.3/css/dx.light.css" />
<script src="https://unpkg.com/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.js");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
.dx-menu-item-content span {
margin-right: 5px;
}
.dx-menu-item-has-submenu .dx-icon-spinright {
position: absolute;
top: 7px;
right: 2px;
}
.item-badge {
text-align: center;
float: left;
margin-right: 12px;
color: white;
width: 18px;
height: 18px;
font-size: 19.5px;
border-radius: 18px;
margin-top: 2px;
}
export const data = [
{
text: 'Watercolor Landscape',
roomId: [1],
startDate: new Date('2020-11-01T17:30:00.000Z'),
endDate: new Date('2020-11-01T19:00:00.000Z'),
recurrenceRule: 'FREQ=WEEKLY;BYDAY=MO,TH;COUNT=10',
}, {
text: 'Oil Painting for Beginners',
roomId: [2],
startDate: new Date('2020-11-01T17:30:00.000Z'),
endDate: new Date('2020-11-01T19:00:00.000Z'),
recurrenceRule: 'FREQ=WEEKLY;BYDAY=SU,WE;COUNT=10',
}, {
text: 'Testing',
roomId: [3],
startDate: new Date('2020-11-01T20:00:00.000Z'),
endDate: new Date('2020-11-01T21:00:00.000Z'),
recurrenceRule: 'FREQ=WEEKLY;BYDAY=SU;WKST=TU;INTERVAL=2;COUNT=2',
}, {
text: 'Meeting of Instructors',
roomId: [4],
startDate: new Date('2020-11-01T17:00:00.000Z'),
endDate: new Date('2020-11-01T17:15:00.000Z'),
recurrenceRule: 'FREQ=DAILY;BYDAY=TU;UNTIL=20201203',
}, {
text: 'Recruiting students',
roomId: [5],
startDate: new Date('2020-10-24T18:00:00.000Z'),
endDate: new Date('2020-10-24T19:00:00.000Z'),
recurrenceRule: 'FREQ=YEARLY;BYWEEKNO=50;WKST=SU',
recurrenceException: '20201212T190000Z',
}, {
text: 'Final exams',
roomId: [3],
startDate: new Date('2020-10-24T20:00:00.000Z'),
endDate: new Date('2020-10-24T21:35:00.000Z'),
recurrenceRule: 'FREQ=YEARLY;BYWEEKNO=51;BYDAY=WE,TH',
}, {
text: 'Monthly Planning',
roomId: [4],
startDate: new Date('2020-11-24T22:30:00.000Z'),
endDate: new Date('2020-11-24T23:45:00.000Z'),
recurrenceRule: 'FREQ=MONTHLY;BYMONTHDAY=28;COUNT=1',
}, {
text: 'Open Day',
roomId: [5],
startDate: new Date('2020-11-01T17:30:00.000Z'),
endDate: new Date('2020-11-01T21:00:00.000Z'),
recurrenceRule: 'FREQ=YEARLY;BYYEARDAY=333',
},
];
export const resourcesData = [
{
text: 'Room 101',
id: 1,
color: '#bbd806',
}, {
text: 'Room 102',
id: 2,
color: '#f34c8a',
}, {
text: 'Room 103',
id: 3,
color: '#ae7fcc',
}, {
text: 'Meeting room',
id: 4,
color: '#ff8817',
}, {
text: 'Conference hall',
id: 5,
color: '#03bb92',
},
];
window.config = {
transpiler: 'plugin-babel',
meta: {
'devextreme/localization.js': {
'esModule': true,
},
},
paths: {
'npm:': 'https://unpkg.com/',
},
defaultExtension: 'js',
map: {
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types@15.8.1/prop-types.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.28.0/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@22.2.3/cjs',
'devextreme-react': 'npm:devextreme-react@22.2.3',
'jszip': 'npm:jszip@3.7.1/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@1.5.18/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.1.65/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.37/dist/dx-gantt.js',
'@devextreme/runtime': 'npm:@devextreme/runtime@3.0.11',
'inferno': 'npm:inferno@7.4.11/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat@7.4.11/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate@7.4.11/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode@7.4.11/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class@7.4.11/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras@7.4.11/dist/inferno-extras.min.js',
// SystemJS plugins
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.7.1/standalone.js',
'prettier/parser-html': 'npm:prettier@2.7.1/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:@devextreme/runtime@3.0.11/inferno/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
react: true,
},
};
System.config(window.config);